{
    "$graph": [
        {
            "class": "CommandLineTool",
            "id": "#bwa-mem-PE.cwl",
            "label": "bwa-mem-PE-0.7.4--ha92aebf_0",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/bwa:0.7.4--ha92aebf_0"
                }
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "baseCommand": [
                "bwa",
                "mem"
            ],
            "inputs": [
                {
                    "id": "#bwa-mem-PE.cwl/bwa-mem-PE-0.7.4--ha92aebf_0/ref",
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "doc": "Fasta reference (e.g., hs37d5)",
                    "secondaryFiles": [
                        ".amb",
                        ".ann",
                        ".bwt",
                        ".pac",
                        ".sa"
                    ]
                },
                {
                    "id": "#bwa-mem-PE.cwl/bwa-mem-PE-0.7.4--ha92aebf_0/fq1",
                    "type": "File",
                    "format": "http://edamontology.org/format_1930",
                    "inputBinding": {
                        "position": 3
                    },
                    "doc": "FastQ file from next-generation sequencers"
                },
                {
                    "id": "#bwa-mem-PE.cwl/bwa-mem-PE-0.7.4--ha92aebf_0/fq2",
                    "type": "File",
                    "format": "http://edamontology.org/format_1930",
                    "inputBinding": {
                        "position": 4
                    },
                    "doc": "FastQ file from next-generation sequencers"
                }
            ],
            "stdout": "output.sam",
            "arguments": [
                {
                    "position": 1,
                    "prefix": "-t",
                    "valueFrom": "4"
                }
            ],
            "outputs": [
                {
                    "id": "#bwa-mem-PE.cwl/bwa-mem-PE-0.7.4--ha92aebf_0/sam",
                    "type": "File",
                    "format": "http://edamontology.org/format_2573",
                    "outputBinding": {
                        "glob": "output.sam"
                    }
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "fastqc",
            "inputs": [
                {
                    "id": "#fastqc.cwl/fastq",
                    "type": "File",
                    "format": "http://edamontology.org/format_1930",
                    "inputBinding": {
                        "position": 2
                    },
                    "doc": "FastQ file from next-generation sequencers"
                }
            ],
            "outputs": [
                {
                    "id": "#fastqc.cwl/qc",
                    "type": "File",
                    "outputBinding": {
                        "glob": "*_fastqc.html"
                    }
                }
            ],
            "label": "fastqc",
            "arguments": [
                {
                    "position": 1,
                    "prefix": "-o",
                    "valueFrom": "."
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/fastqc:0.11.7--pl5.22.0_2"
                }
            ],
            "id": "#fastqc.cwl"
        },
        {
            "class": "CommandLineTool",
            "id": "#trimmomaticPE.cwl",
            "label": "trimmomatic-0.38",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/trimmomatic:0.38--1"
                }
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "baseCommand": [
                "java",
                "-jar"
            ],
            "inputs": [
                {
                    "id": "#trimmomaticPE.cwl/trimmomatic-0.38/fq1",
                    "type": "File",
                    "format": "http://edamontology.org/format_1930",
                    "inputBinding": {
                        "position": 3
                    },
                    "doc": "FastQ file from next-generation sequencers"
                },
                {
                    "id": "#trimmomaticPE.cwl/trimmomatic-0.38/fq2",
                    "type": "File",
                    "format": "http://edamontology.org/format_1930",
                    "inputBinding": {
                        "position": 4
                    },
                    "doc": "FastQ file from next-generation sequencers"
                }
            ],
            "outputs": [
                {
                    "id": "#trimmomaticPE.cwl/trimmomatic-0.38/trimFq1P",
                    "type": "File",
                    "format": "http://edamontology.org/format_1930",
                    "outputBinding": {
                        "glob": "$(inputs.fq1.basename).trim.1P.fastq"
                    }
                },
                {
                    "id": "#trimmomaticPE.cwl/trimmomatic-0.38/trimFq1U",
                    "type": "File",
                    "format": "http://edamontology.org/format_1930",
                    "outputBinding": {
                        "glob": "$(inputs.fq1.basename).trim.1U.fastq"
                    }
                },
                {
                    "id": "#trimmomaticPE.cwl/trimmomatic-0.38/trimFq2P",
                    "type": "File",
                    "format": "http://edamontology.org/format_1930",
                    "outputBinding": {
                        "glob": "$(inputs.fq2.basename).trim.2P.fastq"
                    }
                },
                {
                    "id": "#trimmomaticPE.cwl/trimmomatic-0.38/trimFq2U",
                    "type": "File",
                    "format": "http://edamontology.org/format_1930",
                    "outputBinding": {
                        "glob": "$(inputs.fq2.basename).trim.2U.fastq"
                    }
                }
            ],
            "arguments": [
                {
                    "position": 1,
                    "valueFrom": "/gnu/store/lif9hv9hdf9bsifa0ycnpdrbfxf8mc85-profile/lib/share/jar/trimmomatic-0.38.jar"
                },
                {
                    "position": 2,
                    "valueFrom": "PE"
                },
                {
                    "position": 5,
                    "valueFrom": "$(inputs.fq1.basename).trim.1P.fastq"
                },
                {
                    "position": 6,
                    "valueFrom": "$(inputs.fq1.basename).trim.1U.fastq"
                },
                {
                    "position": 7,
                    "valueFrom": "$(inputs.fq2.basename).trim.2P.fastq"
                },
                {
                    "position": 8,
                    "valueFrom": "$(inputs.fq2.basename).trim.2U.fastq"
                },
                {
                    "position": 9,
                    "valueFrom": "ILLUMINACLIP:/gnu/store/lif9hv9hdf9bsifa0ycnpdrbfxf8mc85-profile/lib/share/jar/adapters/TruSeq2-PE.fa:2:40:15"
                }
            ]
        },
        {
            "class": "Workflow",
            "id": "#main",
            "label": "test-workflow",
            "inputs": [
                {
                    "type": "File",
                    "format": "http://edamontology.org/format_1930",
                    "doc": "FastQ file from next-generation sequencers",
                    "id": "#main/fq1"
                },
                {
                    "type": "File",
                    "format": "http://edamontology.org/format_1930",
                    "doc": "FastQ file from next-generation sequencers",
                    "id": "#main/fq2"
                },
                {
                    "type": "File",
                    "format": "http://edamontology.org/format_1929",
                    "doc": "reference (e.g., hs37d5) in fasta format",
                    "id": "#main/ref"
                }
            ],
            "steps": [
                {
                    "label": "map",
                    "doc": "Mapping onto a reference genome",
                    "run": "#bwa-mem-PE.cwl",
                    "in": [
                        {
                            "source": "#main/trimPE/trimFq1P",
                            "id": "#main/map/fq1"
                        },
                        {
                            "source": "#main/trimPE/trimFq2P",
                            "id": "#main/map/fq2"
                        },
                        {
                            "source": "#main/ref",
                            "id": "#main/map/ref"
                        }
                    ],
                    "out": [
                        "#main/map/sam"
                    ],
                    "id": "#main/map"
                },
                {
                    "label": "qc1",
                    "doc": "Quality control for fastq file (fq1) before trimming",
                    "run": "#fastqc.cwl",
                    "in": [
                        {
                            "source": "#main/fq1",
                            "id": "#main/qc1/fastq"
                        }
                    ],
                    "out": [
                        "#main/qc1/qc"
                    ],
                    "id": "#main/qc1"
                },
                {
                    "label": "qc1P",
                    "doc": "Quality control for fastq file (fq1) after trimming",
                    "run": "#fastqc.cwl",
                    "in": [
                        {
                            "source": "#main/trimPE/trimFq1P",
                            "id": "#main/qc1P/fastq"
                        }
                    ],
                    "out": [
                        "#main/qc1P/qc"
                    ],
                    "id": "#main/qc1P"
                },
                {
                    "label": "qc2",
                    "doc": "Quality control for fastq file (fq2) before trimming",
                    "run": "#fastqc.cwl",
                    "in": [
                        {
                            "source": "#main/fq2",
                            "id": "#main/qc2/fastq"
                        }
                    ],
                    "out": [
                        "#main/qc2/qc"
                    ],
                    "id": "#main/qc2"
                },
                {
                    "label": "qc2P",
                    "doc": "Quality control for fastq file (fq2) after trimming",
                    "run": "#fastqc.cwl",
                    "in": [
                        {
                            "source": "#main/trimPE/trimFq2P",
                            "id": "#main/qc2P/fastq"
                        }
                    ],
                    "out": [
                        "#main/qc2P/qc"
                    ],
                    "id": "#main/qc2P"
                },
                {
                    "label": "trimPE",
                    "doc": "adaptor trimming",
                    "run": "#trimmomaticPE.cwl",
                    "in": [
                        {
                            "source": "#main/fq1",
                            "id": "#main/trimPE/fq1"
                        },
                        {
                            "source": "#main/fq2",
                            "id": "#main/trimPE/fq2"
                        }
                    ],
                    "out": [
                        "#main/trimPE/trimFq1P",
                        "#main/trimPE/trimFq2P"
                    ],
                    "id": "#main/trimPE"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/qc1/qc",
                    "id": "#main/oqc1"
                },
                {
                    "type": "File",
                    "outputSource": "#main/qc1P/qc",
                    "id": "#main/oqc1P"
                },
                {
                    "type": "File",
                    "outputSource": "#main/qc2/qc",
                    "id": "#main/oqc2"
                },
                {
                    "type": "File",
                    "outputSource": "#main/qc2P/qc",
                    "id": "#main/oqc2P"
                },
                {
                    "type": "File",
                    "outputSource": "#main/map/sam",
                    "id": "#main/sam"
                }
            ]
        }
    ],
    "cwlVersion": "v1.0",
    "$namespaces": {
        "edam": "http://edamontology.org/"
    }
}
